/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"time"
)

// checks if the Highlight type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Highlight{}

// Highlight struct for Highlight
type Highlight struct {
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	ConfigurationId string `json:"configuration_id"`
	Template string `json:"template"`
	Metric HighlightMetric `json:"metric"`
	Frequency Frequency `json:"frequency"`
	GuestsEntryPoint *string `json:"guests_entry_point,omitempty"`
	OutsideBusinessHours bool `json:"outside_business_hours"`
	Weekdays []int32 `json:"weekdays"`
	StartAt time.Time `json:"start_at"`
	EndAt time.Time `json:"end_at"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewHighlight instantiates a new Highlight object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewHighlight(id string, organizationId string, configurationId string, template string, metric HighlightMetric, frequency Frequency, outsideBusinessHours bool, weekdays []int32, startAt time.Time, endAt time.Time, createdAt time.Time, updatedAt time.Time) *Highlight {
	this := Highlight{}
	this.Id = id
	this.OrganizationId = organizationId
	this.ConfigurationId = configurationId
	this.Template = template
	this.Metric = metric
	this.Frequency = frequency
	this.OutsideBusinessHours = outsideBusinessHours
	this.Weekdays = weekdays
	this.StartAt = startAt
	this.EndAt = endAt
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewHighlightWithDefaults instantiates a new Highlight object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewHighlightWithDefaults() *Highlight {
	this := Highlight{}
	return &this
}

// GetId returns the Id field value
func (o *Highlight) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *Highlight) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *Highlight) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *Highlight) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetConfigurationId returns the ConfigurationId field value
func (o *Highlight) GetConfigurationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConfigurationId
}

// GetConfigurationIdOk returns a tuple with the ConfigurationId field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetConfigurationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConfigurationId, true
}

// SetConfigurationId sets field value
func (o *Highlight) SetConfigurationId(v string) {
	o.ConfigurationId = v
}

// GetTemplate returns the Template field value
func (o *Highlight) GetTemplate() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Template
}

// GetTemplateOk returns a tuple with the Template field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetTemplateOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Template, true
}

// SetTemplate sets field value
func (o *Highlight) SetTemplate(v string) {
	o.Template = v
}

// GetMetric returns the Metric field value
func (o *Highlight) GetMetric() HighlightMetric {
	if o == nil {
		var ret HighlightMetric
		return ret
	}

	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetMetricOk() (*HighlightMetric, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Metric, true
}

// SetMetric sets field value
func (o *Highlight) SetMetric(v HighlightMetric) {
	o.Metric = v
}

// GetFrequency returns the Frequency field value
func (o *Highlight) GetFrequency() Frequency {
	if o == nil {
		var ret Frequency
		return ret
	}

	return o.Frequency
}

// GetFrequencyOk returns a tuple with the Frequency field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetFrequencyOk() (*Frequency, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Frequency, true
}

// SetFrequency sets field value
func (o *Highlight) SetFrequency(v Frequency) {
	o.Frequency = v
}

// GetGuestsEntryPoint returns the GuestsEntryPoint field value if set, zero value otherwise.
func (o *Highlight) GetGuestsEntryPoint() string {
	if o == nil || IsNil(o.GuestsEntryPoint) {
		var ret string
		return ret
	}
	return *o.GuestsEntryPoint
}

// GetGuestsEntryPointOk returns a tuple with the GuestsEntryPoint field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Highlight) GetGuestsEntryPointOk() (*string, bool) {
	if o == nil || IsNil(o.GuestsEntryPoint) {
		return nil, false
	}
	return o.GuestsEntryPoint, true
}

// HasGuestsEntryPoint returns a boolean if a field has been set.
func (o *Highlight) HasGuestsEntryPoint() bool {
	if o != nil && !IsNil(o.GuestsEntryPoint) {
		return true
	}

	return false
}

// SetGuestsEntryPoint gets a reference to the given string and assigns it to the GuestsEntryPoint field.
func (o *Highlight) SetGuestsEntryPoint(v string) {
	o.GuestsEntryPoint = &v
}

// GetOutsideBusinessHours returns the OutsideBusinessHours field value
func (o *Highlight) GetOutsideBusinessHours() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.OutsideBusinessHours
}

// GetOutsideBusinessHoursOk returns a tuple with the OutsideBusinessHours field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetOutsideBusinessHoursOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OutsideBusinessHours, true
}

// SetOutsideBusinessHours sets field value
func (o *Highlight) SetOutsideBusinessHours(v bool) {
	o.OutsideBusinessHours = v
}

// GetWeekdays returns the Weekdays field value
func (o *Highlight) GetWeekdays() []int32 {
	if o == nil {
		var ret []int32
		return ret
	}

	return o.Weekdays
}

// GetWeekdaysOk returns a tuple with the Weekdays field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetWeekdaysOk() ([]int32, bool) {
	if o == nil {
		return nil, false
	}
	return o.Weekdays, true
}

// SetWeekdays sets field value
func (o *Highlight) SetWeekdays(v []int32) {
	o.Weekdays = v
}

// GetStartAt returns the StartAt field value
func (o *Highlight) GetStartAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.StartAt
}

// GetStartAtOk returns a tuple with the StartAt field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetStartAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.StartAt, true
}

// SetStartAt sets field value
func (o *Highlight) SetStartAt(v time.Time) {
	o.StartAt = v
}

// GetEndAt returns the EndAt field value
func (o *Highlight) GetEndAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.EndAt
}

// GetEndAtOk returns a tuple with the EndAt field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetEndAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.EndAt, true
}

// SetEndAt sets field value
func (o *Highlight) SetEndAt(v time.Time) {
	o.EndAt = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *Highlight) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *Highlight) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *Highlight) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *Highlight) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *Highlight) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o Highlight) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Highlight) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["configuration_id"] = o.ConfigurationId
	toSerialize["template"] = o.Template
	toSerialize["metric"] = o.Metric
	toSerialize["frequency"] = o.Frequency
	if !IsNil(o.GuestsEntryPoint) {
		toSerialize["guests_entry_point"] = o.GuestsEntryPoint
	}
	toSerialize["outside_business_hours"] = o.OutsideBusinessHours
	toSerialize["weekdays"] = o.Weekdays
	toSerialize["start_at"] = o.StartAt
	toSerialize["end_at"] = o.EndAt
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableHighlight struct {
	value *Highlight
	isSet bool
}

func (v NullableHighlight) Get() *Highlight {
	return v.value
}

func (v *NullableHighlight) Set(val *Highlight) {
	v.value = val
	v.isSet = true
}

func (v NullableHighlight) IsSet() bool {
	return v.isSet
}

func (v *NullableHighlight) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableHighlight(val *Highlight) *NullableHighlight {
	return &NullableHighlight{value: val, isSet: true}
}

func (v NullableHighlight) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableHighlight) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


